<?php

declare(strict_types=1);

namespace Pdahal\Xmpp\Buffers;

class Response implements Buffer
{
    protected array $response = [];

    public function write(?string $data = null): void
    {
        if ($data) {
            $this->response[] = $data;
        }
    }

    public function read(): string
    {
        $implodedResponse = $this->response != [] ? implode('', $this->response) : '';
        $this->flush();

        return $implodedResponse;
    }

    protected function flush(): void
    {
        $this->response = [];
    }

    public function getCurrentBufferData(): array
    {
        return $this->response;
    }
}
