<?php

declare(strict_types=1);

namespace Pdahal\Xmpp\Loggers;

interface Loggable
{
    /**
     * Standard log message
     */
    public function log(string $message): void;

    /**
     * Shorthand method for logging with prepended "REQUEST" string
     */
    public function logRequest(string $message): void;

    /**
     * Shorthand method for logging with prepended "RESPONSE" string
     */
    public function logResponse(string $message): void;

    /**
     * Shorthand method for logging with prepended "ERROR" string
     */
    public function error(string $message): void;

    /**
     * Returns relative path from given resource
     */
    public function getFilePathFromResource(mixed $resource): string;
}
