<?php

declare(strict_types=1);

namespace Pdahal\Xmpp\Xml\Stanzas;

use Pdahal\Xmpp\Socket;
use Pdahal\Xmpp\Xml\Xml;

abstract class Stanza
{
    use Xml;

    public function __construct(protected Socket $socket)
    {
    }

    protected function uniqueId(): string
    {
        return uniqid();
    }

    protected function readResponseFile(): string|false
    {
        $logger = $this->socket->getOptions()->getLogger();
        $responseFilePath = $logger->getFilePathFromResource($logger->log);
        $responseFile = fopen($responseFilePath, 'r');

        return fread($responseFile, filesize($responseFilePath));
    }
}
